Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.netlib.lapack
Class DLARRB

    java.lang.Object
      org.netlib.lapack.DLARRB

    public class DLARRB

extends java.lang.Object

    DLARRB is a simplified interface to the JLAPACK routine dlarrb.
    This interface converts Java-style 2D row-major arrays into
    the 1D column-major linearized arrays expected by the lower
    level JLAPACK routines.  Using this interface also allows you
    to omit offset and leading dimension arguments.  However, because
    of these conversions, these routines will be slower than the low
    level ones.  Following is the description from the original Fortran
    source.  Contact seymour@cs.utk.edu with any questions.

     *     ..
     *
     *  Purpose
     *  =======
     *
     *  Given the relatively robust representation(RRR) L D L^T, DLARRB
     *  does "limited" bisection to refine the eigenvalues of L D L^T,
     *  W( IFIRST-OFFSET ) through W( ILAST-OFFSET ), to more accuracy. Initi
     *  guesses for these eigenvalues are input in W, the corresponding estim
     *  of the error in these guesses and their gaps are input in WERR
     *  and WGAP, respectively. During bisection, intervals
     *  [left, right] are maintained by storing their mid-points and
     *  semi-widths in the arrays W and WERR respectively.
     *
     *  Arguments
     *  =========
     *
     *  N       (input) INTEGER
     *          The order of the matrix.
     *
     *  D       (input) DOUBLE PRECISION array, dimension (N)
     *          The N diagonal elements of the diagonal matrix D.
     *
     *  LLD     (input) DOUBLE PRECISION array, dimension (N-1)
     *          The (N-1) elements L(i)*L(i)*D(i).
     *
     *  IFIRST  (input) INTEGER
     *          The index of the first eigenvalue to be computed.
     *
     *  ILAST   (input) INTEGER
     *          The index of the last eigenvalue to be computed.
     *
     *  RTOL1   (input) DOUBLE PRECISION
     *  RTOL2   (input) DOUBLE PRECISION
     *          Tolerance for the convergence of the bisection intervals.
     *          An interval [LEFT,RIGHT] has converged if
     *          RIGHT-LEFT.LT.MAX( RTOL1*GAP, RTOL2*MAX(|LEFT|,|RIGHT|) )
     *          where GAP is the (estimated) distance to the nearest
     *          eigenvalue.
     *
     *  OFFSET  (input) INTEGER
     *          Offset for the arrays W, WGAP and WERR, i.e., the IFIRST-OFFS
     *          through ILAST-OFFSET elements of these arrays are to be used.
     *
     *  W       (input/output) DOUBLE PRECISION array, dimension (N)
     *          On input, W( IFIRST-OFFSET ) through W( ILAST-OFFSET ) are
     *          estimates of the eigenvalues of L D L^T indexed IFIRST throug
     *          ILAST.
     *          On output, these estimates are refined.
     *
     *  WGAP    (input/output) DOUBLE PRECISION array, dimension (N-1)
     *          On input, the (estimated) gaps between consecutive
     *          eigenvalues of L D L^T, i.e., WGAP(I-OFFSET) is the gap betwe
     *          eigenvalues I and I+1. Note that if IFIRST.EQ.ILAST
     *          then WGAP(IFIRST-OFFSET) must be set to ZERO.
     *          On output, these gaps are refined.
     *
     *  WERR    (input/output) DOUBLE PRECISION array, dimension (N)
     *          On input, WERR( IFIRST-OFFSET ) through WERR( ILAST-OFFSET )
     *          the errors in the estimates of the corresponding elements in
     *          On output, these errors are refined.
     *
     *  WORK    (workspace) DOUBLE PRECISION array, dimension (2*N)
     *          Workspace.
     *
     *  IWORK   (workspace) INTEGER array, dimension (2*N)
     *          Workspace.
     *
     *  PIVMIN  (input) DOUBLE PRECISION
     *          The minimum pivot in the Sturm sequence.
     *
     *  SPDIAM  (input) DOUBLE PRECISION
     *          The spectral diameter of the matrix.
     *
     *  TWIST   (input) INTEGER
     *          The twist index for the twisted factorization that is used
     *          for the negcount.
     *          TWIST = N: Compute negcount from L D L^T - LAMBDA I = L+ D+ L
     *          TWIST = 1: Compute negcount from L D L^T - LAMBDA I = U- D- U
     *          TWIST = R: Compute negcount from L D L^T - LAMBDA I = N(r) D(
     *
     *  INFO    (output) INTEGER
     *          Error flag.
     *
     *  Further Details
     *  ===============
     *
     *  Based on contributions by
     *     Beresford Parlett, University of California, Berkeley, USA
     *     Jim Demmel, University of California, Berkeley, USA
     *     Inderjit Dhillon, University of Texas, Austin, USA
     *     Osni Marques, LBNL/NERSC, USA
     *     Christof Voemel, University of California, Berkeley, USA
     *
     *  =====================================================================
     *
     *     .. Parameters ..

Constructor Summary
`DLARRB()`

Method Summary
`static void` | `DLARRB(int n, double[] d, double[] lld, int ifirst, int ilast, double rtol1, double rtol2, int offset, double[] w, double[] wgap, double[] werr, double[] work, int[] iwork, double pivmin, double spdiam, int twist, intW info)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DLARRB

    public DLARRB()

Method Detail

### DLARRB

    public static void DLARRB(int n,
                              double[] d,
                              double[] lld,
                              int ifirst,
                              int ilast,
                              double rtol1,
                              double rtol2,
                              int offset,
                              double[] w,
                              double[] wgap,
                              double[] werr,
                              double[] work,
                              int[] iwork,
                              double pivmin,
                              double spdiam,
                              int twist,
                              intW info)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD